#ifndef WAVELET_OPENCL_PARAM_COMB_H
#define WAVELET_OPENCL_PARAM_COMB_H

#include "main.h"
#include "Wavelet.h"
#include "WaveletOpenclParam.h"
#include <sstream>

/**
 * @brief Program parameters structure
 */
class WaveletOpenclParamComb : public WaveletOpenclParam
  {
    public:
		  /**
       * Default constructor for set initial undefined value.
       */
		  WaveletOpenclParamComb();
		  /**
       * Get program build parameters.
		   * @param block_size threads in block count
		   * @param stat_creating statistics creating type
		   * @return parameters
       */
      std::string createBuildParam();
      /**
       * Print debug information
       */
      void printDebug();
      void clear();
      proc_dim comb_sizes;
      std::string comb_kernel;
      cl_uint comb_hor_corners_proc;
  };

#endif
